SHOPX/SHOPX/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

from rest_framework_swagger.views import get_swagger_view

schema_view = get_swagger_view(title='API')

urlpatterns = [
    path('admin/', admin.site.urls),
    url('chaining/', include('smart_selects.urls')),
    path('shopping/', include('shopping.urls')),
    path('user/', include('user.urls')),
    path('swagger/', schema_view),
]
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

SHOPX/user/urls.py
from django.urls import path, include
from user.views import *

urlpatterns = [
    path('', include('django.contrib.auth.urls')),
    path('register/', register, name='register'),
    path('login_shopx/', login_own, name='login_own'),
    path('logout/', logout_own, name='logout_own'),
    path('notification/', notification, name='notification'),
]

SHOPX/shopping/models.py
from django.contrib.auth.models import User
from django.db import models
from smart_selects.db_fields import ChainedForeignKey
from django.core.exceptions import ValidationError

from client.models import Client


# Бренды или Компании
class Brand(models.Model):
    name = models.CharField('Имя компании', max_length=50)

    class Meta:
        verbose_name = 'Фирма|Бренд'
        verbose_name_plural = 'Фирмы|Бренды'
        ordering = ['id']

    def __str__(self):
        return self.name


# Город
class City(models.Model):
    name = models.CharField(max_length=80, verbose_name='Город')

    class Meta:
        verbose_name = 'Город'
        verbose_name_plural = "Городы"
        ordering = ['id']

    def __str__(self):
        return self.name


# Категории. Пример Вода
class Category(models.Model):
    name = models.CharField(max_length=100, verbose_name='Имя категории')
    city = models.ManyToManyField(City, verbose_name='Выбор Города')
    image = models.ImageField(verbose_name='ФОТО', upload_to='category_image/')

    class Meta:
        verbose_name = 'Категория'
        verbose_name_plural = 'Категории'
        ordering = ['id']

    def __str__(self):
        return self.name


#  Под-категория. Пример Газировка
class SubCategory(models.Model):
    category = models.ForeignKey(Category, on_delete=models.SET_NULL, null=True, verbose_name='Выбор Категории')
    name = models.CharField(max_length=100, verbose_name='Имя Под-Категории')
    active = models.BooleanField(verbose_name='Активный', default=True)
    image = models.ImageField(verbose_name='ФОТО', upload_to='subcategory_image/')

    class Meta:
        verbose_name = 'Под-Категория'
        verbose_name_plural = 'Под-Категории'
        ordering = ['id']

    def __str__(self):
        return self.name


# Главный продукт. Пример Кола/Пепси ...
class Product(models.Model):
    currency = [
        ('SOM', 'Сом'),
        ('USD', 'Доллар'),
        ('EURO', 'Евро'),
        ('RUB', 'Рубль'),
    ]
    category = models.ForeignKey(Category, on_delete=models.SET_NULL, null=True, verbose_name='Категория')
    sub_category = ChainedForeignKey(SubCategory,
                                     chained_field='category',
                                     chained_model_field='category',
                                     show_all=False,
                                     auto_choose=True,
                                     sort=True,
                                     verbose_name='Под-категория')
    brand = models.ForeignKey(Brand, on_delete=models.SET_NULL, null=True, blank=True)
    name = models.CharField(max_length=100, verbose_name='Имя продукта')
    description = models.TextField(verbose_name='Описание')
    image = models.ImageField(verbose_name='ФОТО', upload_to='image/')
    cur = models.CharField(max_length=4, choices=currency, default='SOM', verbose_name='Волюта')
    price = models.IntegerField(verbose_name='Цена')
    amount = models.PositiveIntegerField(verbose_name='Кол-во', default=1)
    article = models.IntegerField(verbose_name='Артикл', unique=True, null=True)
    active = models.BooleanField(verbose_name='Активный', default=True)
    date = models.DateField(verbose_name='Дата публикации', auto_now_add=True, blank=True, null=True)

    class Meta:
        verbose_name = 'Продукт'
        verbose_name_plural = 'Продукты'
        ordering = ['id']

    def __str__(self):
        return '{name} {sub_category}'.format(name=self.name, sub_category=self.sub_category)


# Заказ Покупателья
class Order(models.Model):
    name = models.ForeignKey(verbose_name='Имя Покупателья', to=Client, on_delete=models.SET_NULL, null=True)
    PAY_TYPE = {
        ('CASH', 'Наличными'),
        ('CARD', 'Карта'),
    }
    pay = models.CharField(max_length=20, verbose_name='Оплата', choices=PAY_TYPE, null=True)
    category = models.ForeignKey(Category, on_delete=models.SET_NULL, null=True, verbose_name='Категория')
    sub_category = ChainedForeignKey(SubCategory,
                                     chained_field='category',
                                     chained_model_field='category',
                                     show_all=False,
                                     auto_choose=True,
                                     sort=True,
                                     verbose_name='Под-категория')
    # product = ChainedForeignKey(Product,
    #                             chained_field='sub_category',
    #                             chained_model_field='sub_category',
    #                             show_all=False,
    #                             auto_choose=True,
    #                             sort=True,
    #                             verbose_name='Продукт')
    quality = models.IntegerField('Количество')

    class Meta:
        verbose_name = 'Заказ'
        verbose_name_plural = 'Заказы'
        ordering = ['id']

    def __str__(self):
        return '{name}'.format(name=self.name)


# Заказанный Продукт
class ItemOrder(models.Model):
    product = models.ForeignKey(Product, models.SET_NULL, null=True, verbose_name='Продукт')
    quantity = models.IntegerField(verbose_name='Кол-во', default=1)
    order = models.ForeignKey(Order, models.SET_NULL, null=True, verbose_name='Заказ')

    class Meta:
        verbose_name = 'Заказ'
        verbose_name_plural = 'Заказы'
        ordering = ['id']

    def __str__(self):
        return '{product} {order}'.format(product=self.product, order=self.order)


class FeedBack(models.Model):
    name = models.CharField(max_length=100, verbose_name='Имя Клиента')
    description = models.TextField(verbose_name='Описание')
    image = models.ImageField(verbose_name='ФОТО', upload_to='feedback/')
    date = models.DateField(verbose_name='Дата публикации', auto_now_add=True, blank=True, null=True)

    class Meta:
        verbose_name = 'Отзыв'
        verbose_name_plural = 'Отзывы'
        ordering = ['id']

    def __str__(self):
        return self.name


class Comment(models.Model):
    name = models.TextField()
    product = models.ForeignKey(Product, on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    created_at = models.DateTimeField(auto_now_add=True)

    class Meta:
        verbose_name = 'Коментария'
        verbose_name_plural = 'Коментарии'
        ordering = ['id']

    def __str__(self):
        return self.name

SHOPX/templates/add.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <form action="{% url 'add' %}" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ category.as_p }}
        <button type="submit">Submit</button>
    </form>
{% endblock %}



{#    <form action="{% url 'feedback' %}" method="post">#}
{#        {% csrf_token %}#}
{##}
{#        <input type="text" name="name">#}
{#        <input type="text" name="text">#}
{#        <input type="file" name="img">#}
{#        <button type="submit">OK</button>#}
{#    </form>#}

SHOPX/templates/base.html
<!DOCTYPE html>

{% load static %}

<html lang="en">
   <head>
      <!-- basic -->
      <meta charset="utf-8">
      <meta http-equiv="X-UA-Compatible" content="IE=edge">
      <!-- mobile metas -->
      <meta name="viewport" content="width=device-width, initial-scale=1">
      <meta name="viewport" content="initial-scale=1, maximum-scale=1">
      <!-- site metas -->
      <title>SHOPX</title>
      <meta name="keywords" content="">
      <meta name="description" content="">
      <meta name="author" content="">

      <!-- bootstrap css -->
      <link type="text/css" rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
      <!-- style css -->
      <link type="text/css" rel="stylesheet" href="{% static 'css/style.css' %}">
      <!-- Responsive-->
      <link type="text/css" rel="stylesheet" href="{% static 'css/responsive.css' %}">
      <!-- fevicon -->
      <link rel="icon" href="#" type="image/gif" />
      <!-- Scrollbar Custom CSS -->
      <link type="text/css" rel="stylesheet" href="{% static 'css/jquery.mCustomScrollbar.min.css' %}">
      <!-- Tweaks for older IEs-->
      <link type="text/css" rel="stylesheet" href="https://netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css">
      <link type="text/css" rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/2.1.5/jquery.fancybox.min.css" media="screen">
      <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
      <![endif]-->


   </head>

<body class="main-layout inner_page">

      {% include 'header.html' %}

      {% block content %}
      {% endblock %}

      {% include 'footer.html' %}

      <!-- Javascript files-->
      <script src="{% static 'js/jquery.min.js' %}"></script>
      <script src="{% static 'js/popper.min.js' %}"></script>
      <script src="{% static 'js/bootstrap.bundle.min.js' %}"></script>
      <script src="{% static 'js/jquery-3.0.0.min.js' %}"></script>
      <!-- sidebar -->
      <script src="{% static 'js/jquery.mCustomScrollbar.concat.min.js' %}"></script>
      <script src="{% static 'js/custom.js' %}"></script>

</body>
</html>

SHOPX/templates/category.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>ALL CATEGORIES</h2>
                        <p>Here you can see and choose the category</p>
                    </div>
                </div>
            </div>
            <div class="row">
                {% for x in category %}

                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if x.image %}
                                    <figure><img src="{{ x.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h3>{{ x.name }}</h3>
                                <a class="read_more" href="{% url 'category_subcategory' x.id %}">See More</a>
                            </div>
                        </div>
                    </div>

                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/category_subcategory.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>SUBCATEGORIES</h2>
                        <p>Here you can see and choose the subcategory</p>
                    </div>
                </div>
            </div>
            <div class="row">
                {% for x in category_subcategory %}

                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if x.image %}
                                    <figure><img src="{{ x.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h3>{{ x.name }}</h3>
                                <a class="read_more" href="{% url 'category_subcategory_product' x.category_id x.id %}">See More</a>
                            </div>
                        </div>
                    </div>

                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/category_subcategory_product.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>PRODUCTS</h2>
                        <p>Here you can see and choose the Products</p>
                    </div>
                </div>
            </div>
            <div class="row">
                {% for x in category_subcategory_product %}

                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if x.image %}
                                    <figure><img src="{{ x.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h4>$<strong class="yellow">{{ x.price }}</strong></h4>
                                <h3>{{ x.name }}</h3>
                                <p>{{ x.description }}</p>
                                <a class="read_more" href="{% url 'private_product' x.id %}">See More</a>
                            </div>
                        </div>
                    </div>

                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/footer.html
{% load static %}

{% if user.is_authenticated %}
<!--  footer -->
<footer id="contact">
 <div class="footer">
    <div class="container">
       <div class="row">
          <div class="col-md-12">
             <div class="titlepage">
                <h2>Contact Us</h2>
             </div>
          </div>
          <div class="col-md-10 offset-md-1">
             <form id="request" class="main_form">
                <div class="row">
                   <div class="col-md-12 ">
                      <input class="contactus" placeholder="Full Name" type="type" name="Full Name">
                   </div>
                   <div class="col-md-7">
                      <input class="contactus" placeholder="Email" type="type" name="Email">
                   </div>
                   <div class="col-md-7">
                      <input class="contactus" placeholder="Phone Number" type="type" name="Phone Number">
                   </div>
                   <div class="col-xl-5 col-lg-5 col-md-5 col-sm-12">
                      <ul class="social_icon">
                         <h3>Follow Me</h3>
                         <li><a href="#"><i class="fa fa-facebook" aria-hidden="true"></i></a></li>
                         <li><a href="#"><i class="fa fa-twitter" aria-hidden="true"></i></a></li>
                         <li><a href="#"><i class="fa fa-linkedin-square" aria-hidden="true"></i></a></li>
                         <li><a href="#"><i class="fa fa-instagram" aria-hidden="true"></i></a></li>
                      </ul>
                   </div>
                   <div class="col-md-12">
                      <textarea class="contactus1" placeholder="Message" type="type" Message="Name">Message </textarea>
                   </div>
                   <div class="col-md-12">
                      <button class="send_btn">Send</button>
                   </div>
                </div>
             </form>
          </div>
          <div class="col-md-10 offset-md-1">
             <ul class="location_icon">
                <li><a href="#"><i class="fa fa-map-marker" aria-hidden="true"></i></a> Bishkek</li>
                <li><a href="#"><i class="fa fa-volume-control-phone" aria-hidden="true"></i></a> +996 778 67-89-98</li>
                <li><a href="#"><i class="fa fa-envelope" aria-hidden="true"></i></a>anasbinkurban@gmail.com</li>
             </ul>
          </div>
       </div>
    </div>
 </div>
</footer>
<!-- end footer -->
{% endif %}

SHOPX/templates/header.html
{% load static %}

<!-- loader  -->
      <div class="loader_bg">
         <div class="loader"><img src="{% static 'images/loading.gif' %}" alt="#" /></div>
      </div>
      <!-- end loader -->
      <!-- header -->
      <header>
         <!-- header inner -->
         <div class="header">
            <div class="container">
               <div class="row">
                  <div class="col-xl-3 col-lg-3 col-md-3 col-sm-3 col logo_section">
                     <div class="full">
                        <div class="center-desk">
                           <div class="logo">
                              <div class="col-md-6">
                                 <div class="test_box">
                                    <div class="text-bg">
                                       <h1><span><a href="{% url 'home' %}"><h1>SHOPX</h1><!-- <img src="images/logo.png" alt="#" /> --></a></span></h1>
                                    </div>
                                 </div>
                              </div>
                           </div>
                        </div>
                     </div>
                  </div>
                  <div class="col-xl-9 col-lg-9 col-md-9 col-sm-9">
                     <nav class="navigation navbar navbar-expand-md navbar-dark ">
                        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarsExample04" aria-controls="navbarsExample04" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                        </button>
                        <div class="collapse navbar-collapse" id="navbarsExample04">

                           <ul class="navbar-nav mr-auto">
                              <li class="nav-item">
                                 <a class="nav-link" href="{% url 'home' %}"> Home  </a>
                              </li>
                               {% if user.is_authenticated %}
                                  <li class="nav-item">
                                    <a class="nav-link" href="{% url 'category' %}">Category</a>
                                  </li>
                                   <li class="nav-item">
                                     <a class="nav-link" href="{% url 'subcategory' %}">Sub-Category</a>
                                  </li>
                                  <li class="nav-item">
                                     <a class="nav-link" href="{% url 'product' %}">Product</a>
                                  </li>
                                  <li class="nav-item">
                                     <a class="nav-link" href="{% url 'add' %}">Add</a>
                                  </li>
                                  <li class="nav-item">
                                     <a class="nav-link" href="{% url 'logout_own' %}">Log Out</a>
                                  </li>
                               {% else %}

                                  <li class="nav-item">
                                     <a class="nav-link" href="{% url 'notification' %}">Product</a>
                                  </li>
                                  <li class="nav-item">
                                     <a class="nav-link" href="{% url 'login_own' %}">Log In</a>
                                  </li>
                               {% endif %}


                              <!-- Search -->
                              <!-- <li class="nav-item d_none">
                                 <a class="nav-link" href="#"><i class="fa fa-search" aria-hidden="true"></i></a>
                              </li> -->

                           </ul>
                        </div>
                     </nav>
                  </div>
               </div>
            </div>
         </div>
      </header>
      <!-- end header -->

SHOPX/templates/private_product.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>{{ private_product.name }}</h2>
                        <p>Here you can see our product</p>
                    </div>
                </div>
            </div>
            <div class="row">
                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if private_product.image %}
                                    <figure><img src="{{ private_product.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h4>$<strong class="yellow">{{ private_product.price }}</strong></h4>
                                <h3>{{ private_product.name }}</h3>
                                <p>{{ private_product.description }}</p>
                                <a class="read_more" href="#">Order Now</a>
                            </div>
                            <div>
                                <hr>
                                    {% for comment in private_product.comment_set.all %}
                                        <div class="comment-item">
                                            <small class="comment" contenteditable="true" style="outline: none">User name</small>
                                            <h5 class="comment-user">{{ comment.user.username }}</h5>

                                        <small class="comment">Comment</small>
                                            <h5>
                                                {{ comment.name }} &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                {% if comment.user == user %}
                                                <button type="submit" name="edit_private_product">
                                                    <a href="{% url 'private_product_edit' private_product.id comment.id %}"
                                                       style="text-decoration:none;color:white;">
                                                    Edit
                                                    </a></button>
                                                {% endif %}
                                            </h5>
                                        </div>
                                        <hr>
                                    {% endfor %}
                                <hr>
                            {% if request.user.is_authenticated %}
                                <form action="{% url 'private_product' private_product.id %}" method="post">
                                {% csrf_token %}
                                    <input type="text" name="name">
                                <button type="submit"> ADD</button>
                                </form>
                            {% endif %}
                            </div>
                        </div>
                    </div>
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/private_product_edit.html
{% extends 'base.html' %}

{% load static %}

{% block content %}

    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>{{ private_product.name }}</h2>
                        <p>Here you can Edit your comments</p>
                    </div>
                </div>
            </div>
            <div class="row">
                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if private_product.image %}
                                    <figure><img src="{{ private_product.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h4>$<strong class="yellow">{{ private_product.price }}</strong></h4>
                                <h3>{{ private_product.name }}</h3>
                                <p>{{ private_product.description }}</p>
                                <a class="read_more" href="#">Order Now</a>
                            </div>
                            <div>
                                <hr>
                                    {% for comment in private_product.comment_set.all %}
                                        <div class="comment-item">
                                            <small class="comment" contenteditable="true" style="outline: none">User name</small>
                                            <h5 class="comment-user">{{ comment.user.username }}</h5>

                                        <small class="comment">Comment</small>
                                                {% if comment.user == user %}
                                                    {% if private_product_comment == comment %}
                                                        <form action="{% url 'private_product_edit' private_product.id comment.id %}" method="post">
                                                        {% csrf_token %}
                                                            <input type="text" name="name" placeholder="{{ private_product_comment.name }}">
                                                        <button type="submit">Edit</button>
                                                        </form>

                                                    {% else %}
                                                        <button type="submit" name="edit_private_product">
                                                            <a href="{% url 'private_product_edit' private_product.id comment.id %}"
                                                               style="text-decoration:none;color:white;">
                                                            Edit
                                                            </a>
                                                        </button>
                                                    {% endif %}
                                                {% else %}
                                                    <h5>
                                                        {{ comment.name }} &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                    </h5>
                                                {% endif %}
                                        </div>
                                        <hr>
                                    {% endfor %}
                                <hr>
                            </div>
                        </div>
                    </div>
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/product.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>Our Product</h2>
                        <p>Here you can see our product</p>
                    </div>
                </div>
            </div>
            <div class="row">
                {% for x in product %}

                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if x.image %}
                                    <figure><img src="{{ x.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h4>$<strong class="yellow">{{ x.price }}</strong></h4>
                                <h3>{{ x.name }}</h3>
                                <p>{{ x.description }}</p>
                                <a class="read_more" href="{% url 'private_product' x.id %}">See More</a>
                            </div>
                        </div>
                    </div>

                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}

SHOPX/templates/subcategory.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
    <div class="juices">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="titlepage">
                        <h2>ALL SUBCATEGORIES</h2>
                        <p>Here you can see and choose the subcategory</p>
                    </div>
                </div>
            </div>
            <div class="row">
                {% for x in subcategory %}

                    <div class="col-md-4">
                        <div class="our_main_box">
                            <div class="our_img">
                                {% if x.image %}
                                    <figure><img src="{{ x.image.url }}" class="card-img-top" alt="#" height="200px">
                                    </figure>
                                {% endif %}
                            </div>
                            <div class="our_text">
                                <h3>{{ x.name }}</h3>
                                <a class="read_more" href="{% url 'subcategory_product' x.id %}">See More</a>
                            </div>
                        </div>
                    </div>

                {% endfor %}
            </div>
        </div>
    </div>

{% endblock %}